# haystack

Port of [haystack](https://bitbucket.org/brianfrank/haystack-java) java toolkit. Use it to connect and work with SkySpark. 
[Project Haystack]`http://project-haystack.org/` defines a tagging model and REST API for sensor systems such as HVAC, lighting, and energy equipment.
[SkySpark] is a project to serve your IoT data and make analytics.

To use this package you need installed SkySpark server (and apply a some license). 
Authentication methods are skipped now, so you can use this library from SkySpark pub folder.
Just create in you SkySpark's folder root 'pub' directory and place here your app. 
It will be accessible by 'localhost_or_smth:80/pub/my_app.html'. 
Only client side is implemented at this moment, you can't use it from server or command-line apps. 

## Usage

A simple usage example (include this into HTML page):

    import 'package:haystack/core.dart';
    import 'package:haystack/hclient.dart';
    
    final String uri = "http://localhost:8080/api/demo";
    final String user = "haystack";
    final String pass = "testpass";
    HClient client;
    
    main() {
      client = new HClient(uri, user, pass);
      client.open().then((_) => client.about()).then((HDict result) {
        print(result);
      });
    }

## Features and bugs

Please file feature requests and bugs at the [issue tracker][tracker].

[tracker]: https://bitbucket.org/bassg/haystack-dart-toolkit/issues
