///
/// Copyright (c) 2016, BAS Services & Graphics, LLC.
/// Licensed under the Academic Free License version 3.0
///

library haystack.hna;

import 'HVal.dart';

/// HNA is the singleton value used to indicate not available.
///
/// @see <a href='http://project-haystack.org/doc/TagModel#tagKinds'>Project Haystack</a>
///
class HNA extends HVal {
  /// Singleton value
  static final HNA VAL = new HNA._();

  HNA._() {}

  /// Hash code
  @override
  int get hashCode => 0x6e61;

  /// Equals is based on reference
  bool equals(Object that) => this == that;

  /// Encode as "na"
  String toString() => "na";

  /// Encode as "z:"
  String toJson() => "z:";

  /// Encode as "NA"
  String toZinc() => "NA";
}
