///
/// Copyright (c) 2015, BAS Services & Graphics, LLC.
/// Licensed under the Academic Free License version 3.0
///

library haystack.hremove;

import 'HVal.dart';

/// HRemove is the singleton value used to indicate a tag remove.
///
/// See [Project Haystack](http://project-haystack.org/doc/TagModel#tagKinds)
class HRemove extends HVal {

  /** Singleton value */
  static final HRemove VAL = new HRemove._();

  /** Factory constructor from string value */
  factory HRemove (String val) => VAL;

  /** Private constructor */
  HRemove._();

  /** Hash code */
  int get hashCode => 0x8ab3;

  /** Equals is based on reference */
  bool operator ==(Object that) => identical(this, that);

  /** Encode as "remove" */
  @override
  String toString() => 'remove';

  /** Encode as "x:" */
  String toJson() => "x:";

  /** Encode as "R" */
  String toZinc() => 'R';
}