///
/// Copyright (c) 2015, BAS Services & Graphics, LLC.
/// Licensed under the Academic Free License version 3.0
///

library haystack.hval;

/// HVal is the base class for representing haystack tag
/// scalar values as an immutable class.
///
/// See [Project Haystack](http://project-haystack.org/doc/TagModel#tagKinds)
abstract class HVal {

  /** Hash code is value based */
  int get hashCode;

  /** String format is for human consumption only */
  @override
  String toString() => toZinc();

  /** Encode value to zinc format */
  String toZinc();

  /** Encode to JSON string value */
  String toJson();

  /** Return sort order as negative, 0, or positive */
  int compareTo(Object that) {
    return toString().compareTo(that.toString());
  }

}