///
/// Copyright (c) 2015, BAS Services & Graphics, LLC.
/// Licensed under the Academic Free License version 3.0
///

part of haystack.src.hclient;

/// CallErrException is thrown then a HClient.call returns a
/// HGrid with the err marker tag indicating a server side error.
class CallErrError extends CallError {

  static String _getMsg(HGrid grid) {
    HVal dis = grid.meta.get("dis", checked:false);
    if (dis is HStr) return dis.val;
    return "server side error";
  }

  factory CallErrError(HGrid grid) {
    String msg = _getMsg(grid);
    return new CallErrError._(grid, msg);
  }

  CallErrError._(HGrid this.grid, String msg) : super(msg);

  /** Error grid returned by server */
  final HGrid grid;

  /** Get the server side stack trace or return null if not available */
  String get trace {
    HVal val = grid.meta.get("errTrace", checked:false);
    if (val is HStr) return val.toString();
    return null;
  }
}