List<String> tags = new List.unmodifiable([
  "name",
  "absorption",
  "ahu",
  "ahuRef",
  "air",
  "airCooled",
  "area",
  "blowdown",
  "boiler",
  "boilerPlant",
  "boilerPlantRef",
  "bypass",
  "centrifugal",
  "chilled",
  "chilledBeamZone",
  "chilledWaterCool",
  "chiller",
  "chillerPlant",
  "chillerPlantRef",
  "circuit",
  "closedLoop",
  "cmd",
  "co",
  "co2",
  "coldDeck",
  "condensate",
  "condenser",
  "connection",
  "constantVolume",
  "cool",
  "coolOnly",
  "cooling",
  "coolingCapacity",
  "coolingTower",
  "cur",
  "curErr",
  "curStatus",
  "curVal",
  "current",
  "damper",
  "delta",
  "device",
  "device1Ref",
  "device2Ref",
  "directZone",
  "dis",
  "discharge",
  "domestic",
  "dualDuct",
  "ductArea",
  "dxCool",
  "effective",
  "efficiency",
  "elec",
  "elecHeat",
  "elecMeterLoad",
  "elecMeterRef",
  "elecPanel",
  "elecPanelOf",
  "elecReheat",
  "enable",
  "energy",
  "entering",
  "enum",
  "equip",
  "equipRef",
  "evaporator",
  "exhaust",
  "faceBypass",
  "fan",
  "fanPowered",
  "fcu",
  "filter",
  "flow",
  "freezeStat",
  "freq",
  "gas",
  "gasMeterLoad",
  "geoAddr",
  "geoCity",
  "geoCoord",
  "geoCountry",
  "geoCounty",
  "geoPostalCode",
  "geoState",
  "geoStreet",
  "heat",
  "heatExchanger",
  "heatPump",
  "heatWheel",
  "heating",
  "his",
  "hisErr",
  "hisInterpolate",
  "hisStatus",
  "hisTotalized",
  "hot",
  "hotDeck",
  "hotWaterHeat",
  "hotWaterReheat",
  "humidifier",
  "humidity",
  "hvac",
  "id",
  "isolation",
  "kind",
  "leaving",
  "lightLevel",
  "lighting",
  "lights",
  "lightsGroup",
  "load",
  "makeup",
  "max",
  "maxVal",
  "meter",
  "min",
  "minVal",
  "mixed",
  "multiZone",
  "network",
  "networkRef",
  "neutralDeck",
  "occ",
  "occupancyIndicator",
  "occupied",
  "openLoop",
  "outside",
  "parallel",
  "perimeterHeat",
  "pf",
  "phase",
  "point",
  "power",
  "pressure",
  "pressureDependent",
  "pressureIndependent",
  "primaryFunction",
  "primaryLoop",
  "protocol",
  "pump",
  "reciprocal",
  "refrig",
  "reheat",
  "reheating",
  "return",
  "rooftop",
  "run",
  "screw",
  "secondaryLoop",
  "sensor",
  "series",
  "singleDuct",
  "site",
  "siteMeter",
  "sitePanel",
  "siteRef",
  "sp",
  "speed",
  "stage",
  "standby",
  "steam",
  "steamHeat",
  "steamMeterLoad",
  "subPanelOf",
  "submeterOf",
  "sunrise",
  "temp",
  "tripleDuct",
  "tz",
  "unit",
  "unocc",
  "uv",
  "valve",
  "variableVolume",
  "vav",
  "vavMode",
  "vavZone",
  "vfd",
  "volt",
  "volume",
  "water",
  "waterCooled",
  "waterMeterLoad",
  "weather",
  "weatherCond",
  "weatherPoint",
  "weatherRef",
  "wetBulb",
  "writable",
  "writeErr",
  "writeLevel",
  "writeStatus",
  "writeVal",
  "yearBuilt",
  "zone"
]);

List<List<String>> tagsLists = new List.unmodifiable([
//"Discharge",
  ["discharge", "air", "temp", "sensor",],
  ["discharge", "air", "humidity", "sensor",],
  ["discharge", "air", "pressure", "sensor",],
  ["discharge", "air", "flow", "sensor",],
  ["discharge", "air", "fan", "cmd",],
  ["discharge", "air", "fan", "sensor",],

//"Return",
  ["return", "air", "temp", "sensor",],
  ["return", "air", "humidity", "sensor",],
  ["return", "air", "pressure", "sensor",],
  ["return", "air", "flow", "sensor",],
  ["return", "air", "co2", "sensor",],
  ["return", "air", "fan", "cmd",],
  ["return", "air", "damper", "cmd",],

//"Mixed",
  ["mixed", "air", "temp", "sensor",],

//"Outside",
  ["outside", "air", "temp", "sensor",],
  ["outside", "air", "humidity", "sensor",],
  ["outside", "air", "pressure", "sensor",],
  ["outside", "air", "flow", "sensor",],
  ["outside", "air", "flow", "sp",],
  ["outside", "air", "damper", "cmd",],

//"Exhaust",
  ["exhaust", "air", "fan", "cmd",],
  ["exhaust", "air", "damper", "cmd",],

//"Conditioning",
  ["cool", "stage", "cmd",],
  ["heat", "stage", "cmd",],
  ["humidifier", "cmd",],
  ["filter", "sensor",],

//"Misc",
  ["freezeStat", "sensor",],
  ["heatWheel", "cmd",],
  ["faceBypass", "cmd",],
  ["bypass", "damper", "cmd",],

// "Run",/"Status",
  ["run", "cmd",],
  ["run", "sensor",],
  ["enable", "cmd",],
  ["load", "cmd",],
  ["load", "sensor",],
  ["efficiency", "sensor",],
  ["power", "sensor",],
  ["energy", "sensor",],

//"Chilled", "water", "to",/"from", "AHUs",
  ["chilled", "water", "leaving", "temp", "sensor",],
  ["chilled", "water", "leaving", "temp", "sp",],
  ["chilled", "water", "leaving", "flow", "sensor",],
  ["chilled", "water", "leaving", "pressure", "sensor",],
  ["chilled", "water", "entering", "temp", "sensor",],
  ["chilled", "water", "entering", "flow", "sensor",],
  ["chilled", "water", "entering", "pressure", "sensor",],
  ["chilled", "water", "delta", "temp", "sensor",],
  ["chilled", "water", "delta", "flow", "sensor",],
  ["chilled", "water", "delta", "pressure", "sensor",],
  ["chilled", "water", "valve", "isolation", "cmd",],

//"Condenser", "water", "to",/"from", "cooling", "towers",
  ["condenser", "water", "leaving", "temp", "sensor",],
  ["condenser", "water", "leaving", "flow", "sensor",],
  ["condenser", "water", "leaving", "pressure", "sensor",],
  ["condenser", "water", "entering", "temp", "sensor",],
  ["condenser", "water", "entering", "pressure", "sensor",],
  ["condenser", "water", "entering", "flow", "sensor",],
  ["condenser", "water", "valve", "isolation", "cmd",],

//"Misc", "Internal",
  ["condenser", "cmd",],
  ["condenser", "refrig", "temp", "sensor",],
  ["condenser", "refrig", "pressure", "sensor",],
  ["evaporator", "refrig", "temp", "sensor",],
  ["evaporator", "refrig", "pressure", "sensor",],

  // Chilled water to/from AHUs
  ["chilled", "water", "leaving", "temp", "sensor",],
  ["chilled", "water", "leaving", "temp", "sp",],
  ["chilled", "water", "leaving", "flow", "sensor",],
  ["chilled", "water", "leaving", "pressure", "sensor",],
  ["chilled", "water", "entering", "temp", "sensor",],
  ["chilled", "water", "entering", "flow", "sensor",],
  ["chilled", "water", "entering", "pressure", "sensor",],
  ["chilled", "water", "delta", "temp", "sensor",],
  ["chilled", "water", "delta", "flow", "sensor",],
  ["chilled", "water", "delta", "pressure", "sensor",],
  ["chilled", "water", "delta", "pressure", "sp",],
  ["chilled", "water", "bypass", "valve", "cmd",],

  // Condenser water between Chillers/Cooling Towers
  ["condenser", "water", "delta", "pressure", "sensor",],
  ["condenser", "water", "bypass", "valve", "cmd",],

  ["condenser", "water", "leaving", "temp", "sensor",],
  ["condenser", "water", "leaving", "temp", "sp",],
  ["condenser", "water", "leaving", "flow", "sensor",],
  ["condenser", "water", "leaving", "pressure", "sensor",],
  ["condenser", "water", "entering", "temp", "sensor",],
  ["condenser", "water", "entering", "pressure", "sensor",],
  ["condenser", "water", "entering", "flow", "sensor",],
  ["fan", "cmd",],
  ["fan", "sensor",],

  ["power", "sensor",],
  ["energy", "sensor",],
  ["current", "sensor",],
  ["current", "phase", "sensor",],
  ["volt", "sensor",],
  ["volt", "phase", "sensor",],
  ["pf", "sensor",],
  ["pf", "phase", "sensor",],
  ["freq", "sensor",],

  ["chilled", "water", "leaving", "temp", "sensor",],
  ["chilled", "water", "entering", "temp", "sensor",],
  ["condenser", "water", "leaving", "temp", "sensor",],
  ["condenser", "water", "entering", "flow", "sensor",],

  ["discharge", "air", "temp", "sensor",],
  ["discharge", "air", "pressure", "sensor",],
  ["discharge", "air", "flow", "sensor",],
  ["discharge", "air", "flow", "effective", "sp",],
  ["discharge", "air", "flow", "min", "sp",],
  ["discharge", "air", "flow", "max", "sp",],
  ["discharge", "air", "flow", "reheating", "max", "sp",],
  ["discharge", "air", "flow", "standby", "sp",],
  ["discharge", "air", "fan", "cmd",],
  ["discharge", "air", "fan", "sensor",],
  ["discharge", "air", "damper", "cmd",],
  ["entering", "air", "temp", "sensor",],
  ["reheat", "cmd",],
  ["vavMode", "sp",],
  ["ductArea", "sp",],
  ["perimeterHeat", "cmd",],

  ["run", "cmd",],
  ["run", "sensor",],
  ["enable", "cmd",],
  ["speed", "cmd",],
  ["freq", "cmd",],

  ["zone", "air", "temp", "sensor",],
  ["zone", "air", "temp", "effective", "sp",],
  ["zone", "air", "temp", "occ", "cooling", "sp",],
  ["zone", "air", "temp", "occ", "heating", "sp",],
  ["zone", "air", "temp", "unocc", "cooling", "sp",],
  ["zone", "air", "temp", "unocc", "heating", "sp",],
  ["zone", "air", "temp", "standby", "cooling", "sp",],
  ["zone", "air", "temp", "standby", "heating", "sp",],
  ["zone", "air", "humidity", "sensor",],
  ["zone", "air", "co2", "sensor",],
  ["zone", "air", "co2", "sp",],
].map((List<String> items) => new List.unmodifiable(items)));