///
/// Copyright (c) 2016, BAS Services & Graphics, LLC.
/// Licensed under the Academic Free License version 3.0
///

import 'package:haystack/core.dart';
import 'package:test/test.dart';
import 'utils.dart';

main() {
  group("HListTest", ()
  {
    test("Empty", () {
      expect(HList.EMPTY, new HList([]));
      expect(HList.EMPTY, new HList(new List<HVal>(0)));
      expect(HList.EMPTY.size, 0);
      expect(HList.EMPTY.isEmpty, true);
      expect(() => HList.EMPTY.get(0), throws);
    });

    test("Basics", () {
      HRef ref = new HRef("a");
      HStr str = new HStr("string");
      List<HVal> items = [];
      items.add(ref);
      items.add(str);

      HList list = new HList(items);
      expect(list.length, 2);
      expect(list.get(0), ref);
      expect(list.get(1), str);

      expect(list[0], ref);
      expect(list[1], str);
    });

    test("Zinc", () {
      verifyZinc(HList.EMPTY, "[]");
      // TODO: more tests
    });
  });
}
