library haystack.row_test;

import 'package:test/test.dart';
import 'package:haystack/core.dart';

main () {
  group('Test simple', () {
    HGridBuilder b = new HGridBuilder();
    b.addCol("id");
    b.addCol("dis");
    b.addCol("area");
    b.addRow(new List<HVal>.from([new HRef("a"), new HStr("Alpha"), new HNum(1200)]));
    b.addRow(new List<HVal>.from([new HRef("b"), new HStr("Beta"), null ]));

    HGrid g = b.toGrid();
    HRow r = g.row(0);

    test('row is map', () {
        expect(r is Map, equals(true));
    });

    test('row as map', () {
      expect(r.isEmpty, equals(false));
      expect(r.isNotEmpty, equals(true));
      expect(r.containsKey("id"), equals(true));
      expect(r.containsKey("dis"), equals(true));
      expect(r["dis"].toString(), equals("Alpha"));
    });

    test('row forEach', () {
      r.forEach(( String k, HVal v ) {
        expect( r[k], equals( v ));
      });
    });
  });
}
